﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;

namespace WindowsFormsApplication53
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].MaskInput = "{double:-3.6}";
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].MinValue = -180;
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].MaxValue = 180.000;
        }

        private void ultraGrid1_CellChange(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            decimal n;
            bool isDecimal = Decimal.TryParse(e.Cell.GetText(Infragistics.Win.UltraWinMaskedEdit.MaskMode.Raw), out n);
            if (isDecimal)
            {
                if (e.Cell.Column.Index == 1 && Convert.ToDecimal(e.Cell.GetText(Infragistics.Win.UltraWinMaskedEdit.MaskMode.Raw)) > Convert.ToDecimal(e.Cell.Column.MaxValue))
                {
                    e.Cell.Value = e.Cell.Column.MaxValue;
                    e.Cell.SelStart = e.Cell.Text.IndexOf(Thread.CurrentThread.CurrentCulture.NumberFormat.NumberDecimalSeparator);
                }
                else if (e.Cell.Column.Index == 1 && Convert.ToDecimal(e.Cell.GetText(Infragistics.Win.UltraWinMaskedEdit.MaskMode.Raw)) < Convert.ToDecimal(e.Cell.Column.MinValue))
                {
                    e.Cell.Value = e.Cell.Column.MinValue;
                    e.Cell.SelStart = e.Cell.Text.IndexOf(Thread.CurrentThread.CurrentCulture.NumberFormat.NumberDecimalSeparator);
                }
            }
        }
    }
}